#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

int down(int semid, int semnum)	
	/* operazione DOWN sulla componente semnum di semid */
{
  struct sembuf sb;

  sb.sem_num=semnum;
  sb.sem_op=-1;
  sb.sem_flg=0;
  return semop(semid,&sb,1);
}

int up(int semid, int semnum)	
	/* operazione UP sulla componente semnum di semid */
{
  struct sembuf sb;

  sb.sem_num=semnum;
  sb.sem_op=1;
  sb.sem_flg=0;
  return semop(semid,&sb,1);
}

int seminit(int semid, int semnum, int initval)
	/* inizializzazione con initval della componente semnum di semid */
{
  union semun
  {
    int val;
    struct semid_ds *buf;
    unsigned short *array;
  } arg;

  arg.val=initval;
  return semctl(semid,semnum,SETVAL,arg);
}

